/* 
 * ribs displacement shader
 *
 * Author: Randolf Schultz
 * For: Swish, Mops example scene
 * Arguments:
 * Km: height of the displacement
 * Nu: Number of ribs
 *
 */

displacement
RSribsdsp(float Km = 0.02; float Nu = 100;)
{
  float	magnitude = 0;
  
  /* Compute the distance the surface should be displaced. */
  magnitude = abs(cos(u*PI*Nu));

  /* Now apply the displacement in the direction of the normal. */
  P += Km * magnitude * normalize(N);

  /* Recalculate the normal. */
  N = calculatenormal(P);
}

