/* 
 * spaced stripes surface shader
 *
 * Author: Randolf Schultz
 * For: Swish, Mops example scene
 * Arguments:
 * Space: free space between stripes 
 * Width: width of stripes
 * stripe: color of stripe
 *
 */

surface
RSspacedstripessrf(
		   float Ka = 0.8;
		   float Kd = 0.8;
		   float Space = 0.2;
		   float Width = 0.05;
		   color stripe = color "rgb" (.3,.3,.3);)
{
  float select = 0.0;
  normal Nf = faceforward (normalize(N),I);

  if(mod(u,Space) <= Width)
    select = cos(PI*((mod(u,Space)/Width)-0.5));

  if((v>0.975) || (v<0.025))
    select = 1;

  Oi = Os;
  Ci = Os * mix(Cs,stripe,select) * (Ka * ambient() + Kd * diffuse(Nf));
}

