/*
 * The Mops, a free 3D Tcl/Tk/OpenGL/RenderMan modeler
 *
 * The Mops is copyrighted (C) 1998-1999 by Randolf Schultz
 * (rschultz@informatik.uni-rostock.de)
 *
 * See the file License for details.
 *
 */

#include "mops.h"

/* Levels */

int
mops_crtlevel_tcmd(Tcl_Interp * interp,
		   int argc, char *argv[], mops_object *o)
{
  mops_level_object *new = NULL;
  char fname[] = "crtlevel";
  char type = 0;

  if(argc < 3)
    {
      mops_error(interp, MOPS_ARGS, fname, "type");
      return TCL_ERROR;
    }

  if(!strcmp(argv[2],"union"))
    {
      type = MOPS_LTUNION;
    } else
  if(!strcmp(argv[2],"int"))
    {
      type = MOPS_LTINTERSECTION;
    } else
  if(!strcmp(argv[2],"diff"))
    {
      type = MOPS_LTDIFFERENCE;
    }
  if(!strcmp(argv[2],"prim"))
    {
      type = MOPS_LTPRIMITIVE;
    }
  if(!strcmp(argv[2],"level"))
    {
      type = MOPS_LTLEVEL;
    }
  if(!strcmp(argv[2],"tloop"))
    {
      type = MOPS_LTTRIMLOOP;
    }

  if(!(new = calloc(1, sizeof(mops_level_object))))
     {
       mops_error(interp, MOPS_OUTOFMEM, fname, NULL);
       return(TCL_ERROR);
     }

  new->type = type;

  o->object = new;
  o->type = MOPS_OTLEVEL;

 return TCL_OK;
}

/********************************************/
/* mops_free_level:
   free a level                             */
/********************************************/
int
mops_free_level(mops_level_object *level)
{
  if(!level)
    return MOPS_OK;

  free(level);

 return MOPS_OK;
}


/********************************************/
/* mops_copy_level:
   copy a level                             */
/********************************************/
int
mops_copy_level(mops_level_object *source,
		mops_level_object **dest)
{
 int mops_status = MOPS_OK;
 mops_level_object *newo = NULL;

  if(!(newo = calloc(1,sizeof(mops_level_object))))
    return MOPS_OUTOFMEM; 

  memcpy(newo, source, sizeof(mops_level_object)); 
  /* danger! links point to original hierachy */

  *dest = newo;

 return mops_status;
}

