puts "crtshdscn.tcl:"
puts "implements crtshdscn, a proc that according"
puts "to the currently available shaders creates"
puts "a bunch of spheres/lights, each with a shader applied"
puts stderr "Interferes with Shader Property GUIs!"
puts "Usage: In the Console, type: crtshdscn"
# the proc
proc crtshdscn { } {
 global shaderTypeList

    set lb .fu.fMain.fHier.flb.li

    foreach stype $shaderTypeList {
	upvar #0 ${stype}ShaderData sArgArray
	global ${stype}shaders shaderarguments

	eval set shaders \$${stype}shaders(shadernames)

	foreach shadername $shaders {

	    set shaderarguments ""
	   
	    scanShader $shadername shaderarguments
	    update
	    catch [unset $sArgArray]
	    array set sArgArray { dummy 0 }
	    set sArgArray(Name) $shadername
	    set sArgArray(ArgNames) ""
	    set sArgArray(ArgTypes) ""

	    set i [lindex $shaderarguments 2]
	    
	    set j 3
	    while { $i > 0 } {

		set argname [lindex $shaderarguments $j]
		incr j
		set argtype [lindex $shaderarguments $j]
		incr j

		lappend sArgArray(ArgNames) $argname
		lappend sArgArray(ArgTypes) $argtype

		switch $argtype {
		    color {
			set sArgArray(${argname}_R)\
				[expr int([lindex $shaderarguments $j]*255)]
			incr j
			set sArgArray(${argname}_G)\
				[expr int([lindex $shaderarguments $j]*255)]
			incr j
			set sArgArray(${argname}_B)\
				[expr int([lindex $shaderarguments $j]*255)]
			incr j
			set sArgArray(${argname}_A) 0

		    }
		    point {
			set sArgArray(${argname}_X)\
				[lindex $shaderarguments $j]
			incr j
			set sArgArray(${argname}_Y)\
				[lindex $shaderarguments $j]
			incr j
			set sArgArray(${argname}_Z)\
				[lindex $shaderarguments $j]
			incr j
		    }
		    vector {
			set sArgArray(${argname}_X)\
				[lindex $shaderarguments $j]
			incr j
			set sArgArray(${argname}_Y)\
				[lindex $shaderarguments $j]
			incr j
			set sArgArray(${argname}_Z)\
				[lindex $shaderarguments $j]
			incr j
		    }
		    float {
			set sArgArray(${argname})\
				[lindex $shaderarguments $j]
			incr j
		    }
		    string {
			set sArgArray(${argname})\
				[lindex $shaderarguments $j]
			incr j
		    }
		    default {puts stdout "Oops: Ignoring unknown argument type: $argtype!";}
		}
		incr i -1		
	    }

	    $lb selection clear 0 end
	    updateMopsSelect

	    if { $stype == "light" } {
		crtOb light
	    } else {
		crtOb quadric sphere
	    }

	    set index [$lb index end]
	    $lb selection set $index
	    setSelect $index

	    if { $stype != "volume" } {
		setSProp $stype ${stype}ShaderData
	    } else {
		setSProp $stype ${stype}ShaderData interior
	    }

	}
	

    }

 return;
}
