#
# The Mops, a free 3D Tcl/Tk/OpenGL/RenderMan modeler
#
# The Mops is copyrighted (C) 1998-1999 by Randolf Schultz
# (rschultz@informatik.uni-rostock.de)
#
# See the file License for details.
#
# pphk - prettyprint current hot key configuration
# creates a small (one page) LaTeX document containing some
# tables with the current hot keys
# Usage:
# in the Mops console, type:
# >source pphk.tcl; printHotKeys bla.tex
# then, in a real shell:
# >latex bla.tex

#
proc printHotKeys { filename } {
    global mops_main_sc mops_view_sc mops_oa_sc mops_va_sc

    set id [open $filename w]

    puts $id "\\documentclass\[11pt,twocolumn\]\{article\}"
    puts $id "\\title\{The Mops (0.42b) Hot Keys\}"
    puts $id "\\date\{\}"
    puts $id "\\begin\{document\}"
    puts $id "\\topmargin -3cm"
    puts $id "\\maketitle"
    puts $id "\\thispagestyle \{empty\}"
    puts $id "\\enlargethispage \{10cm\}"
    puts $id "\\parindent 0cm"
################
    puts $id "\{\\bf File Operations\}\\\\ Scope: Main Window\\\\"
    puts $id "\\begin\{tabular\}\{\|l\|l\|\}"
    puts $id "\\hline"
    puts $id "Action & Key\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "New & \\verb|$mops_main_sc(New)|\\\\"
    puts $id "\\hline"
    puts $id "Insert & \\verb|$mops_main_sc(Insert)|\\\\"
    puts $id "\\hline"
    puts $id "Replace & \\verb|$mops_main_sc(Replace)|\\\\"
    puts $id "\\hline"
    puts $id "Save & \\verb|$mops_main_sc(Save)|\\\\"
    puts $id "\\hline"
    puts $id "Save as & \\verb|$mops_main_sc(SaveAs)|\\\\"
    puts $id "\\hline"
    puts $id "Export RIB & \\verb|$mops_main_sc(ExportRIB)|\\\\"
    puts $id "\\hline"
    puts $id "Quit & \\verb|$mops_main_sc(Quit)|\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Hide Mops& \\verb|$mops_main_sc(Hide)|\\\\"
    puts $id "\\hline"
    puts $id "\\end\{tabular\}"

    puts $id "\\vspace \{1cm\}\\\\"
################
    puts $id "\{\\bf Edit Operations\}\\\\ Scope: Main Window\\\\"
    puts $id "\\begin\{tabular\}\{\|l\|l\|\}"

    puts $id "\\hline"
    puts $id "Action & Key\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Copy & \\verb|$mops_main_sc(Copy)|\\\\"
    puts $id "\\hline"
    puts $id "Cut & \\verb|$mops_main_sc(Cut)|\\\\"
    puts $id "\\hline"
    puts $id "Paste & \\verb|$mops_main_sc(Paste)|\\\\"
    puts $id "\\hline"
    puts $id "Copy Property & \\verb|$mops_main_sc(CopyP)|\\\\"
    puts $id "\\hline"
    puts $id "Copy Marked Prop& \\verb|$mops_main_sc(ICopyP)|\\\\"
    puts $id "\\hline"
    puts $id "Paste Property& \\verb|$mops_main_sc(PasteP)|\\\\"
    puts $id "\\hline"
    puts $id "Name & \\verb|$mops_main_sc(Name)|\\\\"
    puts $id "\\hline"
    puts $id "Swap & \\verb|$mops_main_sc(Swap)|\\\\"
    puts $id "\\hline"
    puts $id "Undo & \\verb|$mops_main_sc(Undo)|\\\\"
    puts $id "\\hline"
    puts $id "Help & \\verb|$mops_main_sc(Help)|\\\\"
    puts $id "\\hline"
    puts $id "\\end\{tabular\}"

    puts $id "\\vspace \{1cm\}\\\\"
################
    puts $id "\{\\bf View Operations\}\\\\ Scope: View Window\\\\"
    puts $id "\\begin\{tabular\}\{\|l\|l\|\}"
    puts $id "\\hline"
    puts $id "Action & Key\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Quick Render& \\verb|$mops_view_sc(QRender)|\\\\"
    puts $id "\\hline"
    puts $id "Render & \\verb|$mops_view_sc(Render)|\\\\"
    puts $id "\\hline"
    puts $id "Redraw & \\verb|$mops_view_sc(Redraw)|\\\\"
    puts $id "\\hline"
    puts $id "Close & \\verb|$mops_view_sc(Close)|\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Make Front & \\verb|$mops_view_sc(Front)|\\\\"
    puts $id "\\hline"
    puts $id "Make Side & \\verb|$mops_view_sc(Side)|\\\\"
    puts $id "\\hline"
    puts $id "Make Top & \\verb|$mops_view_sc(Top)|\\\\"
    puts $id "\\hline"
    puts $id "Make Perspective & \\verb|$mops_view_sc(Persp)|\\\\"
    puts $id "\\hline"
    puts $id "Make Trim & \\verb|$mops_view_sc(Trim)|\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Halve Size & \\verb|$mops_view_sc(Halve)|\\\\"
    puts $id "\\hline"
    puts $id "Double Size & \\verb|$mops_view_sc(Double)|\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Draw Wireframe & \\verb|$mops_view_sc(Wire)|\\\\"
    puts $id "\\hline"
    puts $id "Draw Surface & \\verb|$mops_view_sc(Surf)|\\\\"
    puts $id "\\hline"
    puts $id "Draw Grid & \\verb|$mops_view_sc(Grid)|\\\\"
    puts $id "\\hline"
    puts $id "Set Gridsize & \\verb|$mops_view_sc(SGrid)|\\\\"
    puts $id "\\hline"
    puts $id "Toggle Lighting & \\verb|$mops_view_sc(Light)|\\\\"
    puts $id "\\hline"
    puts $id "Automatic Redraw & \\verb|$mops_view_sc(Auto)|\\\\"
    puts $id "\\hline"
    puts $id "\\end\{tabular\}"

    puts $id "\\newpage"
    puts $id "\\thispagestyle \{empty\}"
    puts $id "\\enlargethispage \{10cm\}"
################
    puts $id "\{\\bf Actions\}\\\\ Scope: View Window\\\\"
    puts $id "\\begin\{tabular\}\{\|l\|l\|\}"
    puts $id "\\hline"
    puts $id "Action & Key\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Move & \\verb|$mops_oa_sc(MoveO)|\\\\"
    puts $id "\\hline"
    puts $id "Rotate around Origin & \\verb|$mops_oa_sc(RotO)|\\\\"
    puts $id "\\hline"
    puts $id "Rotate around Point& \\verb|$mops_oa_sc(RotA)|\\\\"
    puts $id "\\hline"
    puts $id "Scale 1D (X)& \\verb|$mops_oa_sc(ScalX)|\\\\"
    puts $id "\\hline"
    puts $id "Scale 1D (Y)& \\verb|$mops_oa_sc(ScalY)|\\\\"
    puts $id "\\hline"
    puts $id "Scale 1D (Z)& \\verb|$mops_oa_sc(ScalZ)|\\\\"
    puts $id "\\hline"
    puts $id "Scale 2D & \\verb|$mops_oa_sc(Scal2)|\\\\"
    puts $id "\\hline"
    puts $id "Scale 3D & \\verb|$mops_oa_sc(Scal3)|\\\\"
    puts $id "\\hline"
    puts $id "Stretch 2D & \\verb|$mops_oa_sc(Stretch)|\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Edit Point& \\verb|$mops_oa_sc(Edit)|\\\\"
    puts $id "\\hline"
    puts $id "Edit Pointcoordinates& \\verb|$mops_oa_sc(EditD)|\\\\"
    puts $id "\\hline"
    puts $id "Edit Weight& \\verb|$mops_oa_sc(WeightE)|\\\\"
    puts $id "\\hline"
    puts $id "Select (tag) Points& \\verb|$mops_oa_sc(Select)|\\\\"
    puts $id "\\hline"
    puts $id "Deselect all Points& \\verb|$mops_oa_sc(DeSelect)|\\\\"
    puts $id "\\hline"
    puts $id "Insert Point (NC)& \\verb|$mops_oa_sc(InsertP)|\\\\"
    puts $id "\\hline"
    puts $id "Delete Point (NC)& \\verb|$mops_oa_sc(DelP)|\\\\"
    puts $id "\\hline"
    puts $id "Split Curve& \\verb|$mops_oa_sc(SplitC)|\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Scale sel. Points (WorldX)& \\verb|$mops_oa_sc(ScalXW)|\\\\"
    puts $id "\\hline"
    puts $id "Scale sel. Points (WorldY)& \\verb|$mops_oa_sc(ScalYW)|\\\\"
    puts $id "\\hline"
    puts $id "Scale sel. Points (WorldZ)& \\verb|$mops_oa_sc(ScalZW)|\\\\"
    puts $id "\\hline"
    puts $id "\\end\{tabular\}"

    puts $id "\\vspace \{1cm\}\\\\"
################
    puts $id "\{\\bf View Actions\}\\\\ Scope: View Window\\\\"
    puts $id "\\begin\{tabular\}\{\|l\|l\|\}"
    puts $id "\\hline"
    puts $id "Action & Key\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Move View& \\verb|$mops_va_sc(MoveV)|\\\\"
    puts $id "\\hline"
    puts $id "Rotate View & \\verb|$mops_va_sc(RotV)|\\\\"
    puts $id "\\hline"
    puts $id "Zoom View & \\verb|$mops_va_sc(ZoomV)|\\\\"
    puts $id "\\hline"
    puts $id "Break Action& \\verb|$mops_va_sc(Break)|\\\\"
    puts $id "\\hline"
    puts $id "\\end\{tabular\}"

    puts $id "\\vspace \{1cm\}\\\\"

    puts $id "\{\\bf Miscellaneous\}\\\\ Scope: View Window\\\\"
    puts $id "\\begin\{tabular\}\{\|l\|l\|\}"
    puts $id "\\hline"
    puts $id "Action & Key\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Move View & Mouse: \\verb|$mops_va_sc(MoveVButton)|\\\\"
    puts $id "\\hline"
    puts $id "Zoom View & Mouse: \\verb|$mops_va_sc(ZoomVButton)|\\\\"
    puts $id "\\hline"
    puts $id "\\hline"
    puts $id "Rotate View (Y, 5Deg)& \\verb|$mops_view_sc(RotL)|\\\\"
    puts $id "\\hline"
    puts $id "Rotate View (Y, -5Deg)& \\verb|$mops_view_sc(RotR)|\\\\"
    puts $id "\\hline"
    puts $id "Rotate View (X, 5Deg)& \\verb|$mops_view_sc(RotU)|\\\\"
    puts $id "\\hline"
    puts $id "Rotate View (X, -5Deg)& \\verb|$mops_view_sc(RotD)|\\\\"
    puts $id "\\hline"
    puts $id "Zoom View In& \\verb|$mops_view_sc(ZoomI)|\\\\"
    puts $id "\\hline"
    puts $id "Zoom View Out& \\verb|$mops_view_sc(ZoomO)|\\\\"
    puts $id "\\hline"
    puts $id "\\end\{tabular\}"

    puts $id "\\end\{document\}"
    close $id

 return;
}
