#
# The Mops, a free 3D Tcl/Tk/OpenGL/RenderMan modeler
#
# The Mops is copyrighted (C) 1998-1999 by Randolf Schultz
# (rschultz@informatik.uni-rostock.de)
#
# See the file License for details.
#
# toinstance.tcl [15. Feb 2000]
#
# Example script for The Mops.
# Adds a little helper function that converts all
# currently selected objects to instances of the
# first selected object and selects all converted
# objects,  so that you may cut them out or delete
# them afterwards.
#
# Usage:
# simply add the path to this script to prefs(scripts)
# > lappend prefs(scripts) "~/mops/src/toinstance.tcl"
# save preferences
# restart The Mops
#
proc instantiate { } {

 set origsel [.fu.fMain.fHier.flb.li curselection]
 set togo [expr [llength $origsel]-1]
 global transfPropData prefs

 set i 1
 while { $i <= $togo } {
     setSelect [lindex $origsel 0]
     updateMopsSelect
     crtOb instance
     updateMopsSelect
     setSelect [lindex $origsel $i]
     getTransfProp
     setSelect [expr [.fu.fMain.fHier.flb.li index end] - 1]
     set prefs(pasteProp) 1
     setTransfProp
     set prefs(pasteProp) 0
     incr i
 }

 set newsel [lrange $origsel 1 end]
 eval [subst "setSelect $newsel"]
 .fu.fMain.fHier.flb.li selection clear 0 end
 foreach s $newsel {
     .fu.fMain.fHier.flb.li selection set $s
 }
    
# setSelect
# updateMopsSelect

 return;
}

if { [winfo exists .tb.finst] } { return; }

set f [frame .tb.finst]

set b1 [button $f.b1 -command {instantiate}\
-text "Instantiate"]
balloon $b1 "make all selected objects\ninstances of the first"
pack $b1 -in $f -side left
pack $f
